## miniaudio 0.11.21+dfsg

=== debian/changelog ===
miniaudio (0.11.21+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Ship miniaudio-libopus and -libvorbis headers from extra/

 -- Matthias Geiger <werdahias@riseup.net>  Mon, 20 Nov 2023 22:01:03 +0100

miniaudio (0.11.20+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 12 Nov 2023 18:59:15 +0100

miniaudio (0.11.18+dfsg-2) unstable; urgency=medium

  * Source-only upload
  * Use proper path in d/install

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 03 Nov 2023 11:54:27 +0200

miniaudio (0.11.18+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #950181)

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 03 Sep 2023 11:34:35 +0200
