=== debian/control ===
Source: miniaudio
Section: libdevel
Priority: optional
Maintainer: Matthias Geiger <werdahias@riseup.net>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.2
Homepage: https://github.com/mackron/miniaudio
Vcs-Browser: https://salsa.debian.org/debian/miniaudio
Vcs-Git: https://salsa.debian.org/debian/miniaudio.git

Package: libminiaudio-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: audio playback and capture library
 miniaudo is a single-file library for audio playback and
 capture supporting a wide range of formats.
 .
 This is a header-only library.
