## miniaudio 0.11.22%2Bdfsg

=== debian/changelog ===
miniaudio (0.11.22+dfsg-1) unstable; urgency=high

  * New upstream release (Closes: #1099609)
    - Includes upstream commit ee506b1, fixing CVE-2024-41147
  * Bump S-V to 4.7.1; no changes needed
  * d/rules: Override cmake build for now
  * d/control: Update my mail address

 -- Matthias Geiger <werdahias@debian.org>  Sun, 09 Mar 2025 13:29:24 +0100
