## miniaudio 0.11.22+dfsg

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: miniaudio
 Section: libdevel
 Priority: optional
-Maintainer: Matthias Geiger <werdahias@riseup.net>
+Maintainer: Matthias Geiger <werdahias@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.6.2
+Standards-Version: 4.7.1
 Homepage: https://github.com/mackron/miniaudio
 Vcs-Browser: https://salsa.debian.org/debian/miniaudio
 Vcs-Git: https://salsa.debian.org/debian/miniaudio.git
