=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

# Don't built the library with cmake for now
override_dh_auto_configure:

override_dh_auto_build:
