=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
repack,compression=gz,\
dversionmangle=s/\+(dfsg)(\.\d+)?$//,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/miniaudio-$1.tar.gz/ \
   https://github.com/mackron/miniaudio/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
