## miniaudio 0.11.23+dfsg

=== debian/changelog ===
miniaudio (0.11.23+dfsg-1) unstable; urgency=medium

  * d/copyright: Exclude tests, too
  * New upstream release
  * d/control: Drop Rules-Require-Root field
  * d/control: Bump Standards-Version to 4.7.2; no changes needed

 -- Matthias Geiger <werdahias@debian.org>  Mon, 24 Nov 2025 18:37:33 +0100
