=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Section: libdevel
 Priority: optional
 Maintainer: Matthias Geiger <werdahias@debian.org>
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Homepage: https://github.com/mackron/miniaudio
 Vcs-Browser: https://salsa.debian.org/debian/miniaudio
 Vcs-Git: https://salsa.debian.org/debian/miniaudio.git
